<template>
  <q-layout view="hHh LpR fFf">
    <q-header class="bg-primary">
      <q-toolbar class="q-pl-none">
        <div class="logo flex flex-center bg-accent">
          <q-avatar
            class="cursor-pointer"
            @click="$router.push('/')"
          >
            <img
              src="favicon.ico"
              height="36"
              width="36"
            >
          </q-avatar>
        </div>

        <q-separator
          vertical
          dark
        />

        <q-space />

        <menu-profile />
      </q-toolbar>
    </q-header>

    <q-drawer
      v-model="drawer"
      content-class="bg-primary"
      :mini-width="70"
      :mini="mini"
      show-if-above
      mini-to-overlay
      @mouseout="mini = true"
      @mouseover="mini = false"
    >
      <q-scroll-area class="fit">
        <q-separator dark />

        <q-list
          separator
          dark
        >
          <menu-item
            v-for="(item, index) in items"
            v-show="$acl.check(item.acl)"
            :key="index"
            :item="item"
            style="padding: 20px"
          />
        </q-list>

        <q-separator dark />
      </q-scroll-area>
    </q-drawer>

    <q-drawer
      v-if="isComposing"
      v-model="drawer"
      content-class="bg-primary"
      show-if-above
      :width="320"
      side="right"
    >
      <q-separator dark />

      <div class="text-center q-px-lg q-pt-lg">
        <q-btn
          class="super-rounded-borders full-width"
          label="Enviar Avaliação"
          text-color="accent"
          padding="14px"
          color="grey-4"
          unelevated
          @click="submit = true"
        />
      </div>

      <card-topic :topic="topic" />

      <div class="text-center q-px-lg">
        <q-btn
          class="super-rounded-borders full-width"
          text-color="accent"
          label="Avaliar"
          padding="14px"
          color="grey-4"
          unelevated
          @click="rating = true"
        />
      </div>
    </q-drawer>

    <q-page-container>
      <router-view
        :rating="rating"
        :submit="submit"
        @topic="setTopic"
        @error="rating = true"
        @rated="rating = false"
        @submitted="submit = false"
      />
    </q-page-container>
  </q-layout>
</template>

<script>
import MenuItem from '../components/drawer/menu-item'
import MenuProfile from '../components/header/menu-profile'
import CardTopic from '../components/composing/card-topic'

export default {
  name: 'Main',
  components: { MenuItem, MenuProfile, CardTopic },
  data () {
    return {
      drawer: false,
      mini: true,
      items: [
        {
          icon: 'fas fa-pencil-alt',
          label: 'Redações',
          to: '/compositions',
          acl: 'isTeacher'
        },
        {
          icon: 'fas fa-tag',
          label: 'Categorias',
          to: '/categories',
          acl: 'isAdmin'
        },
        {
          icon: 'fas fa-lightbulb',
          label: 'Temas',
          to: '/topics',
          acl: 'isAdmin'
        },
        {
          icon: 'fas fa-film',
          label: 'Vídeos',
          to: '/videos',
          acl: 'isAdmin'
        },
        {
          icon: 'fas fa-users',
          label: 'Usuários',
          to: '/users',
          acl: 'isAdmin'
        },
        {
          icon: 'fas fa-hand-holding-usd',
          label: 'Planos',
          to: '/plans',
          acl: 'isAdmin'
        }
      ],
      topic: null,
      submit: false,
      rating: false
    }
  },
  computed: {
    isComposing () {
      return this.$route.path.includes('composing')
    }
  },
  methods: {
    async setTopic (topicId) {
      if (!topicId) {
        this.topic = null

        return undefined
      }

      try {
        const axiosConfig = {
          method: 'GET',
          url: `/Topics/${topicId}`
        }

        this.topic = await this.$axios(axiosConfig).then(R => R.data)
      } catch (err) {
        this.axiosCatch(err)
      }
    }
  }
}
</script>
